
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATxmega128A1
;Program type             : Application
;Clock frequency          : 2.000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 2048 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATxmega128A1
	#pragma AVRPART MEMORY PROG_FLASH 135168
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 16383
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x2000

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU CCP=0x34
	.EQU RAMPD=0x38
	.EQU RAMPX=0x39
	.EQU RAMPY=0x3A
	.EQU RAMPZ=0x3B
	.EQU EIND=0x3C
	.EQU WDT_CTRL=0x80
	.EQU PMIC_CTRL=0xA2
	.EQU NVM_ADDR0=0X01C0
	.EQU NVM_ADDR1=NVM_ADDR0+1
	.EQU NVM_ADDR2=NVM_ADDR1+1
	.EQU NVM_DATA0=NVM_ADDR0+4
	.EQU NVM_CMD=NVM_ADDR0+0xA
	.EQU NVM_CTRLA=NVM_ADDR0+0xB
	.EQU NVM_CTRLB=NVM_ADDR0+0xC
	.EQU NVM_STATUS=NVM_ADDR0+0xF
	.EQU PORTCFG_MPCMASK=0xB0
	.EQU PORTH_DIR=0x6E0
	.EQU PORTH_OUT=0x6E4
	.EQU PORTH_PIN0CTRL=0x6F0
	.EQU PORTJ_DIR=0x700
	.EQU PORTJ_OUT=0x704
	.EQU PORTJ_PIN0CTRL=0x710
	.EQU PORTK_DIR=0x720
	.EQU PORTK_OUT=0x724
	.EQU PORTK_PIN0CTRL=0x730
	.EQU EBI_CTRL=0x0440
	.EQU EBI_SDRAMCTRLA=EBI_CTRL+1
	.EQU EBI_REFRESHL=EBI_CTRL+4
	.EQU EBI_REFRESHH=EBI_CTRL+5
	.EQU EBI_INITDLYL=EBI_CTRL+6
	.EQU EBI_INITDLYH=EBI_CTRL+7
	.EQU EBI_SDRAMCTRLB=EBI_CTRL+8
	.EQU EBI_SDRAMCTRLC=EBI_CTRL+9
	.EQU EBI_CS0_CTRLA=EBI_CTRL+0x10
	.EQU EBI_CS0_CTRLB=EBI_CS0_CTRLA+1
	.EQU EBI_CS0_BASEADDRL=EBI_CS0_CTRLA+2
	.EQU EBI_CS0_BASEADDRH=EBI_CS0_CTRLA+3
	.EQU EBI_CS1_CTRLA=EBI_CTRL+0x14
	.EQU EBI_CS1_CTRLB=EBI_CS1_CTRLA+1
	.EQU EBI_CS1_BASEADDRL=EBI_CS1_CTRLA+2
	.EQU EBI_CS1_BASEADDRH=EBI_CS1_CTRLA+3
	.EQU EBI_CS2_CTRLA=EBI_CTRL+0x18
	.EQU EBI_CS2_CTRLB=EBI_CS2_CTRLA+1
	.EQU EBI_CS2_BASEADDRL=EBI_CS2_CTRLA+2
	.EQU EBI_CS2_BASEADDRH=EBI_CS2_CTRLA+3
	.EQU EBI_CS3_CTRLA=EBI_CTRL+0x1C
	.EQU EBI_CS3_CTRLB=EBI_CS3_CTRLA+1
	.EQU EBI_CS3_BASEADDRL=EBI_CS3_CTRLA+2
	.EQU EBI_CS3_BASEADDRH=EBI_CS3_CTRLA+3
	.EQU EBI_SDCAS_bp=3
	.EQU EBI_SDCAS_bm=8
	.EQU EBI_SDROW_bp=2
	.EQU EBI_SDROW_bm=4
	.EQU EBI_SDCOL_bp=0
	.EQU EBI_MRDLY_bp=6
	.EQU EBI_ROWCYCDLY_bp=3
	.EQU EBI_RPDLY_bp=0
	.EQU EBI_WRDLY_bp=6
	.EQU EBI_ESRDLY_bp=3
	.EQU EBI_ROWCOLDLY_bp=0
	.EQU EBI_CS_SDSREN_bm=4
	.EQU EBI_CS_ASPACE_256B_gc=0x00<<2
	.EQU EBI_CS_ASPACE_512B_gc=0x01<<2
	.EQU EBI_CS_ASPACE_1KB_gc=0x02<<2
	.EQU EBI_CS_ASPACE_2KB_gc=0x03<<2
	.EQU EBI_CS_ASPACE_4KB_gc=0x04<<2
	.EQU EBI_CS_ASPACE_8KB_gc=0x05<<2
	.EQU EBI_CS_ASPACE_16KB_gc=0x06<<2
	.EQU EBI_CS_ASPACE_32KB_gc=0x07<<2
	.EQU EBI_CS_ASPACE_64KB_gc=0x08<<2
	.EQU EBI_CS_ASPACE_128KB_gc=0x09<<2
	.EQU EBI_CS_ASPACE_256KB_gc=0x0A<<2
	.EQU EBI_CS_ASPACE_512KB_gc=0x0B<<2
	.EQU EBI_CS_ASPACE_1MB_gc=0x0C<<2
	.EQU EBI_CS_ASPACE_2MB_gc=0x0D<<2
	.EQU EBI_CS_ASPACE_4MB_gc=0x0E<<2
	.EQU EBI_CS_ASPACE_8MB_gc=0x0F<<2
	.EQU EBI_CS_ASPACE_16M_gc=0x10<<2
	.EQU EBI_CS_MODE_DISABLED_gc=0x00
	.EQU EBI_CS_MODE_SRAM_gc=0x01
	.EQU EBI_CS_MODE_LPC_gc=0x02
	.EQU EBI_CS_MODE_SDRAM_gc=0x03
	.EQU EBI_SDDATAW_4BIT_gc=0x00<<6
	.EQU EBI_SDDATAW_8BIT_gc=0x01<<6
	.EQU EBI_LPCMODE_ALE1_gc=0x00<<4
	.EQU EBI_LPCMODE_ALE12_gc=0x02<<4
	.EQU EBI_SRMODE_ALE1_gc=0x00<<2
	.EQU EBI_SRMODE_ALE2_gc=0x01<<2
	.EQU EBI_SRMODE_ALE12_gc=0x02<<2
	.EQU EBI_SRMODE_NOALE_gc=0x03<<2
	.EQU EBI_IFMODE_DISABLED_gc=0x00
	.EQU EBI_IFMODE_3PORT_gc=0x01
	.EQU EBI_IFMODE_4PORT_gc=0x02
	.EQU EBI_IFMODE_2PORT_gc=0x03
	.EQU EBI_SDCOL_8BIT_gc=0x00
	.EQU EBI_SDCOL_9BIT_gc=0x01
	.EQU EBI_SDCOL_10BIT_gc=0x02
	.EQU EBI_SDCOL_11BIT_gc=0x03
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIO0=0x00
	.EQU GPIO1=0x01
	.EQU GPIO2=0x02
	.EQU GPIO3=0x03
	.EQU GPIO4=0x04
	.EQU GPIO5=0x05
	.EQU GPIO6=0x06
	.EQU GPIO7=0x07
	.EQU GPIO8=0x08
	.EQU GPIO9=0x09
	.EQU GPIO10=0x0A
	.EQU GPIO11=0x0B
	.EQU GPIO12=0x0C
	.EQU GPIO13=0x0D
	.EQU GPIO14=0x0E
	.EQU GPIO15=0x0F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x2000
	.EQU __SRAM_END=0x3FFF
	.EQU __DSTACK_SIZE=0x0800
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF __lcd_x=R2
	.DEF __lcd_y=R5
	.DEF __lcd_maxx=R4

;GPIO0-GPIO15 INITIALIZATION VALUES
	.EQU __GPIO0_INIT=0x00
	.EQU __GPIO1_INIT=0x00
	.EQU __GPIO2_INIT=0x00
	.EQU __GPIO3_INIT=0x00
	.EQU __GPIO4_INIT=0x00
	.EQU __GPIO5_INIT=0x00
	.EQU __GPIO6_INIT=0x00
	.EQU __GPIO7_INIT=0x00
	.EQU __GPIO8_INIT=0x00
	.EQU __GPIO9_INIT=0x00
	.EQU __GPIO10_INIT=0x00
	.EQU __GPIO11_INIT=0x00
	.EQU __GPIO12_INIT=0x00
	.EQU __GPIO13_INIT=0x00
	.EQU __GPIO14_INIT=0x00
	.EQU __GPIO15_INIT=0x00

;GLOBAL REGISTER VARIABLES INITIALIZATION VALUES
	.EQU __R2_INIT=0x00
	.EQU __R3_INIT=0x00
	.EQU __R4_INIT=0x00
	.EQU __R5_INIT=0x00
	.EQU __R6_INIT=0x00
	.EQU __R7_INIT=0x00
	.EQU __R8_INIT=0x00
	.EQU __R9_INIT=0x00
	.EQU __R10_INIT=0x00
	.EQU __R11_INIT=0x00
	.EQU __R12_INIT=0x00
	.EQU __R13_INIT=0x00
	.EQU __R14_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G101:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G101:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

_0x0:
	.DB  0x41,0x44,0x43,0x20,0x25,0x32,0x73,0x20
	.DB  0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2040060:
	.DB  0x1
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G102
	.DW  _0x2040060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  RAMPD,R30
	OUT  RAMPX,R30
	OUT  RAMPY,R30

;MEMORY MAPPED EEPROM ACCESS IS USED
	LDS  R31,NVM_CTRLB
	ORI  R31,0x08
	STS  NVM_CTRLB,R31

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,0xD8
	OUT  CCP,R31
	STS  PMIC_CTRL,R30

;NO EXTERNAL RAM IS USED
	STS  EBI_CTRL,R30

;DISABLE WATCHDOG
	LDS  R26,WDT_CTRL
	CBR  R26,2
	SBR  R26,1
	OUT  CCP,R31
	STS  WDT_CTRL,R26

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

	OUT  RAMPZ,R24

;GPIO0-GPIO15 INITIALIZATION
	LDI  R30,__GPIO0_INIT
	OUT  GPIO0,R30
	;__GPIO1_INIT = __GPIO0_INIT
	OUT  GPIO1,R30
	;__GPIO2_INIT = __GPIO0_INIT
	OUT  GPIO2,R30
	;__GPIO3_INIT = __GPIO0_INIT
	OUT  GPIO3,R30
	;__GPIO4_INIT = __GPIO0_INIT
	OUT  GPIO4,R30
	;__GPIO5_INIT = __GPIO0_INIT
	OUT  GPIO5,R30
	;__GPIO6_INIT = __GPIO0_INIT
	OUT  GPIO6,R30
	;__GPIO7_INIT = __GPIO0_INIT
	OUT  GPIO7,R30
	;__GPIO8_INIT = __GPIO0_INIT
	OUT  GPIO8,R30
	;__GPIO9_INIT = __GPIO0_INIT
	OUT  GPIO9,R30
	;__GPIO10_INIT = __GPIO0_INIT
	OUT  GPIO10,R30
	;__GPIO11_INIT = __GPIO0_INIT
	OUT  GPIO11,R30
	;__GPIO12_INIT = __GPIO0_INIT
	OUT  GPIO12,R30
	;__GPIO13_INIT = __GPIO0_INIT
	OUT  GPIO13,R30
	;__GPIO14_INIT = __GPIO0_INIT
	OUT  GPIO14,R30
	;__GPIO15_INIT = __GPIO0_INIT
	OUT  GPIO15,R30

;GLOBAL REGISTER VARIABLES INITIALIZATION
	;__R2_INIT = __GPIO0_INIT
	MOV  R2,R30
	;__R4_INIT = __GPIO0_INIT
	MOV  R4,R30
	;__R5_INIT = __GPIO0_INIT
	MOV  R5,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x2800

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 5/28/2011
;Author  : NeVaDa
;Company :
;Comments:
;
;
;Chip type               : ATxmega128A1
;Program type            : Application
;AVR Core Clock frequency: 2.000000 MHz
;Memory model            : Small
;Data Stack size         : 2048
;*****************************************************/
;
;// I/O Registers definitions
;#include <io.h>
;
;// Delay functions
;#include <delay.h>
;
;// Alphanumeric LCD interface functions
;#include <alcd.h>
;
;// Declare your global variables here
;#include <delay.h>
;
;#include <stdio.h>
;
;#include <stdlib.h>
;
;char str[10],lcd[10];
;float p;
;
;// System Clocks initialization
;void system_clocks_init(void)
; 0000 002C {

	.CSEG
_system_clocks_init:
; 0000 002D unsigned char n,s;
; 0000 002E 
; 0000 002F // Optimize for speed
; 0000 0030 #pragma optsize-
; 0000 0031 // Save interrupts enabled/disabled state
; 0000 0032 s=SREG;
	ST   -Y,R17
	ST   -Y,R16
;	n -> R17
;	s -> R16
	IN   R16,63
; 0000 0033 // Disable interrupts
; 0000 0034 #asm("cli")
	cli
; 0000 0035 
; 0000 0036 // Internal 2 MHz RC oscillator initialization
; 0000 0037 // Enable the internal 2 MHz RC oscillator
; 0000 0038 OSC.CTRL|=OSC_RC2MEN_bm;
	LDS  R30,80
	ORI  R30,1
	STS  80,R30
; 0000 0039 
; 0000 003A // System Clock prescaler A division factor: 1
; 0000 003B // System Clock prescalers B & C division factors: B:1, C:1
; 0000 003C // ClkPer4: 2000.000 kHz
; 0000 003D // ClkPer2: 2000.000 kHz
; 0000 003E // ClkPer:  2000.000 kHz
; 0000 003F // ClkCPU:  2000.000 kHz
; 0000 0040 n=(CLK.PSCTRL & (~(CLK_PSADIV_gm | CLK_PSBCDIV1_bm | CLK_PSBCDIV0_bm))) |
; 0000 0041 	CLK_PSADIV_1_gc | CLK_PSBCDIV_1_1_gc;
	LDS  R30,65
	ANDI R30,LOW(0x80)
	MOV  R17,R30
; 0000 0042 CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 0043 CLK.PSCTRL=n;
	STS  65,R17
; 0000 0044 
; 0000 0045 // Disable the autocalibration of the internal 2 MHz RC oscillator
; 0000 0046 DFLLRC2M.CTRL&= ~DFLL_ENABLE_bm;
	LDS  R30,104
	ANDI R30,0xFE
	STS  104,R30
; 0000 0047 
; 0000 0048 // Wait for the internal 2 MHz RC oscillator to stabilize
; 0000 0049 while ((OSC.STATUS & OSC_RC2MRDY_bm)==0);
_0x3:
	LDS  R30,81
	ANDI R30,LOW(0x1)
	BREQ _0x3
; 0000 004A 
; 0000 004B // Select the system clock source: 2 MHz Internal RC Osc.
; 0000 004C n=(CLK.CTRL & (~CLK_SCLKSEL_gm)) | CLK_SCLKSEL_RC2M_gc;
	LDS  R30,64
	ANDI R30,LOW(0xF8)
	MOV  R17,R30
; 0000 004D CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 004E CLK.CTRL=n;
	STS  64,R17
; 0000 004F 
; 0000 0050 // Disable the unused oscillators: 32 MHz, 32 kHz, external clock/crystal oscillator, PLL
; 0000 0051 OSC.CTRL&= ~(OSC_RC32MEN_bm | OSC_RC32KEN_bm | OSC_XOSCEN_bm | OSC_PLLEN_bm);
	LDS  R30,80
	ANDI R30,LOW(0xE1)
	STS  80,R30
; 0000 0052 
; 0000 0053 // Peripheral Clock output: Disabled
; 0000 0054 PORTCFG.CLKEVOUT=(PORTCFG.CLKEVOUT & (~PORTCFG_CLKOUT_gm)) | PORTCFG_CLKOUT_OFF_gc;
	LDS  R30,180
	ANDI R30,LOW(0xFC)
	STS  180,R30
; 0000 0055 
; 0000 0056 // Restore interrupts enabled/disabled state
; 0000 0057 SREG=s;
	OUT  0x3F,R16
; 0000 0058 // Restore optimization for size if needed
; 0000 0059 #pragma optsize_default
; 0000 005A }
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;// Ports initialization
;void ports_init(void)
; 0000 005E {
_ports_init:
; 0000 005F // PORTA initialization
; 0000 0060 // OUT register
; 0000 0061 PORTA.OUT=0x00;
	LDI  R30,LOW(0)
	STS  1540,R30
; 0000 0062 // Bit0: Input
; 0000 0063 // Bit1: Input
; 0000 0064 // Bit2: Input
; 0000 0065 // Bit3: Input
; 0000 0066 // Bit4: Input
; 0000 0067 // Bit5: Input
; 0000 0068 // Bit6: Input
; 0000 0069 // Bit7: Input
; 0000 006A PORTA.DIR=0x00;
	STS  1536,R30
; 0000 006B // Bit0 Output/Pull configuration: Totempole/No
; 0000 006C // Bit0 Input/Sense configuration: Sense both edges
; 0000 006D // Bit0 inverted: Off
; 0000 006E // Bit0 slew rate limitation: Off
; 0000 006F PORTA.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1552,R30
; 0000 0070 // Bit1 Output/Pull configuration: Totempole/No
; 0000 0071 // Bit1 Input/Sense configuration: Sense both edges
; 0000 0072 // Bit1 inverted: Off
; 0000 0073 // Bit1 slew rate limitation: Off
; 0000 0074 PORTA.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1553,R30
; 0000 0075 // Bit2 Output/Pull configuration: Totempole/No
; 0000 0076 // Bit2 Input/Sense configuration: Sense both edges
; 0000 0077 // Bit2 inverted: Off
; 0000 0078 // Bit2 slew rate limitation: Off
; 0000 0079 PORTA.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1554,R30
; 0000 007A // Bit3 Output/Pull configuration: Totempole/No
; 0000 007B // Bit3 Input/Sense configuration: Sense both edges
; 0000 007C // Bit3 inverted: Off
; 0000 007D // Bit3 slew rate limitation: Off
; 0000 007E PORTA.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1555,R30
; 0000 007F // Bit4 Output/Pull configuration: Totempole/No
; 0000 0080 // Bit4 Input/Sense configuration: Sense both edges
; 0000 0081 // Bit4 inverted: Off
; 0000 0082 // Bit4 slew rate limitation: Off
; 0000 0083 PORTA.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1556,R30
; 0000 0084 // Bit5 Output/Pull configuration: Totempole/No
; 0000 0085 // Bit5 Input/Sense configuration: Sense both edges
; 0000 0086 // Bit5 inverted: Off
; 0000 0087 // Bit5 slew rate limitation: Off
; 0000 0088 PORTA.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1557,R30
; 0000 0089 // Bit6 Output/Pull configuration: Totempole/No
; 0000 008A // Bit6 Input/Sense configuration: Sense both edges
; 0000 008B // Bit6 inverted: Off
; 0000 008C // Bit6 slew rate limitation: Off
; 0000 008D PORTA.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1558,R30
; 0000 008E // Bit7 Output/Pull configuration: Totempole/No
; 0000 008F // Bit7 Input/Sense configuration: Sense both edges
; 0000 0090 // Bit7 inverted: Off
; 0000 0091 // Bit7 slew rate limitation: Off
; 0000 0092 PORTA.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1559,R30
; 0000 0093 // Interrupt 0 level: Disabled
; 0000 0094 // Interrupt 1 level: Disabled
; 0000 0095 PORTA.INTCTRL=(PORTA.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0096 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1545
	ANDI R30,LOW(0xF0)
	STS  1545,R30
; 0000 0097 // Bit0 pin change interrupt 0: Off
; 0000 0098 // Bit1 pin change interrupt 0: Off
; 0000 0099 // Bit2 pin change interrupt 0: Off
; 0000 009A // Bit3 pin change interrupt 0: Off
; 0000 009B // Bit4 pin change interrupt 0: Off
; 0000 009C // Bit5 pin change interrupt 0: Off
; 0000 009D // Bit6 pin change interrupt 0: Off
; 0000 009E // Bit7 pin change interrupt 0: Off
; 0000 009F PORTA.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1546,R30
; 0000 00A0 // Bit0 pin change interrupt 1: Off
; 0000 00A1 // Bit1 pin change interrupt 1: Off
; 0000 00A2 // Bit2 pin change interrupt 1: Off
; 0000 00A3 // Bit3 pin change interrupt 1: Off
; 0000 00A4 // Bit4 pin change interrupt 1: Off
; 0000 00A5 // Bit5 pin change interrupt 1: Off
; 0000 00A6 // Bit6 pin change interrupt 1: Off
; 0000 00A7 // Bit7 pin change interrupt 1: Off
; 0000 00A8 PORTA.INT1MASK=0x00;
	STS  1547,R30
; 0000 00A9 
; 0000 00AA // PORTB initialization
; 0000 00AB // OUT register
; 0000 00AC PORTB.OUT=0x00;
	STS  1572,R30
; 0000 00AD // Bit0: Input
; 0000 00AE // Bit1: Input
; 0000 00AF // Bit2: Input
; 0000 00B0 // Bit3: Input
; 0000 00B1 // Bit4: Input
; 0000 00B2 // Bit5: Input
; 0000 00B3 // Bit6: Input
; 0000 00B4 // Bit7: Input
; 0000 00B5 PORTB.DIR=0x00;
	STS  1568,R30
; 0000 00B6 // Bit0 Output/Pull configuration: Totempole/No
; 0000 00B7 // Bit0 Input/Sense configuration: Sense both edges
; 0000 00B8 // Bit0 inverted: Off
; 0000 00B9 // Bit0 slew rate limitation: Off
; 0000 00BA PORTB.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1584,R30
; 0000 00BB // Bit1 Output/Pull configuration: Totempole/No
; 0000 00BC // Bit1 Input/Sense configuration: Sense both edges
; 0000 00BD // Bit1 inverted: Off
; 0000 00BE // Bit1 slew rate limitation: Off
; 0000 00BF PORTB.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1585,R30
; 0000 00C0 // Bit2 Output/Pull configuration: Totempole/No
; 0000 00C1 // Bit2 Input/Sense configuration: Sense both edges
; 0000 00C2 // Bit2 inverted: Off
; 0000 00C3 // Bit2 slew rate limitation: Off
; 0000 00C4 PORTB.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1586,R30
; 0000 00C5 // Bit3 Output/Pull configuration: Totempole/No
; 0000 00C6 // Bit3 Input/Sense configuration: Sense both edges
; 0000 00C7 // Bit3 inverted: Off
; 0000 00C8 // Bit3 slew rate limitation: Off
; 0000 00C9 PORTB.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1587,R30
; 0000 00CA // Bit4 Output/Pull configuration: Totempole/No
; 0000 00CB // Bit4 Input/Sense configuration: Sense both edges
; 0000 00CC // Bit4 inverted: Off
; 0000 00CD // Bit4 slew rate limitation: Off
; 0000 00CE PORTB.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1588,R30
; 0000 00CF // Bit5 Output/Pull configuration: Totempole/No
; 0000 00D0 // Bit5 Input/Sense configuration: Sense both edges
; 0000 00D1 // Bit5 inverted: Off
; 0000 00D2 // Bit5 slew rate limitation: Off
; 0000 00D3 PORTB.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1589,R30
; 0000 00D4 // Bit6 Output/Pull configuration: Totempole/No
; 0000 00D5 // Bit6 Input/Sense configuration: Sense both edges
; 0000 00D6 // Bit6 inverted: Off
; 0000 00D7 // Bit6 slew rate limitation: Off
; 0000 00D8 PORTB.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1590,R30
; 0000 00D9 // Bit7 Output/Pull configuration: Totempole/No
; 0000 00DA // Bit7 Input/Sense configuration: Sense both edges
; 0000 00DB // Bit7 inverted: Off
; 0000 00DC // Bit7 slew rate limitation: Off
; 0000 00DD PORTB.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1591,R30
; 0000 00DE // Interrupt 0 level: Disabled
; 0000 00DF // Interrupt 1 level: Disabled
; 0000 00E0 PORTB.INTCTRL=(PORTB.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 00E1 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1577
	ANDI R30,LOW(0xF0)
	STS  1577,R30
; 0000 00E2 // Bit0 pin change interrupt 0: Off
; 0000 00E3 // Bit1 pin change interrupt 0: Off
; 0000 00E4 // Bit2 pin change interrupt 0: Off
; 0000 00E5 // Bit3 pin change interrupt 0: Off
; 0000 00E6 // Bit4 pin change interrupt 0: Off
; 0000 00E7 // Bit5 pin change interrupt 0: Off
; 0000 00E8 // Bit6 pin change interrupt 0: Off
; 0000 00E9 // Bit7 pin change interrupt 0: Off
; 0000 00EA PORTB.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1578,R30
; 0000 00EB // Bit0 pin change interrupt 1: Off
; 0000 00EC // Bit1 pin change interrupt 1: Off
; 0000 00ED // Bit2 pin change interrupt 1: Off
; 0000 00EE // Bit3 pin change interrupt 1: Off
; 0000 00EF // Bit4 pin change interrupt 1: Off
; 0000 00F0 // Bit5 pin change interrupt 1: Off
; 0000 00F1 // Bit6 pin change interrupt 1: Off
; 0000 00F2 // Bit7 pin change interrupt 1: Off
; 0000 00F3 PORTB.INT1MASK=0x00;
	STS  1579,R30
; 0000 00F4 
; 0000 00F5 // PORTC initialization
; 0000 00F6 // OUT register
; 0000 00F7 PORTC.OUT=0x00;
	STS  1604,R30
; 0000 00F8 // Bit0: Input
; 0000 00F9 // Bit1: Input
; 0000 00FA // Bit2: Input
; 0000 00FB // Bit3: Input
; 0000 00FC // Bit4: Input
; 0000 00FD // Bit5: Input
; 0000 00FE // Bit6: Input
; 0000 00FF // Bit7: Input
; 0000 0100 PORTC.DIR=0x00;
	STS  1600,R30
; 0000 0101 // Bit0 Output/Pull configuration: Totempole/No
; 0000 0102 // Bit0 Input/Sense configuration: Sense both edges
; 0000 0103 // Bit0 inverted: Off
; 0000 0104 // Bit0 slew rate limitation: Off
; 0000 0105 PORTC.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1616,R30
; 0000 0106 // Bit1 Output/Pull configuration: Totempole/No
; 0000 0107 // Bit1 Input/Sense configuration: Sense both edges
; 0000 0108 // Bit1 inverted: Off
; 0000 0109 // Bit1 slew rate limitation: Off
; 0000 010A PORTC.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1617,R30
; 0000 010B // Bit2 Output/Pull configuration: Totempole/No
; 0000 010C // Bit2 Input/Sense configuration: Sense both edges
; 0000 010D // Bit2 inverted: Off
; 0000 010E // Bit2 slew rate limitation: Off
; 0000 010F PORTC.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1618,R30
; 0000 0110 // Bit3 Output/Pull configuration: Totempole/No
; 0000 0111 // Bit3 Input/Sense configuration: Sense both edges
; 0000 0112 // Bit3 inverted: Off
; 0000 0113 // Bit3 slew rate limitation: Off
; 0000 0114 PORTC.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1619,R30
; 0000 0115 // Bit4 Output/Pull configuration: Totempole/No
; 0000 0116 // Bit4 Input/Sense configuration: Sense both edges
; 0000 0117 // Bit4 inverted: Off
; 0000 0118 // Bit4 slew rate limitation: Off
; 0000 0119 PORTC.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1620,R30
; 0000 011A // Bit5 Output/Pull configuration: Totempole/No
; 0000 011B // Bit5 Input/Sense configuration: Sense both edges
; 0000 011C // Bit5 inverted: Off
; 0000 011D // Bit5 slew rate limitation: Off
; 0000 011E PORTC.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1621,R30
; 0000 011F // Bit6 Output/Pull configuration: Totempole/No
; 0000 0120 // Bit6 Input/Sense configuration: Sense both edges
; 0000 0121 // Bit6 inverted: Off
; 0000 0122 // Bit6 slew rate limitation: Off
; 0000 0123 PORTC.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1622,R30
; 0000 0124 // Bit7 Output/Pull configuration: Totempole/No
; 0000 0125 // Bit7 Input/Sense configuration: Sense both edges
; 0000 0126 // Bit7 inverted: Off
; 0000 0127 // Bit7 slew rate limitation: Off
; 0000 0128 PORTC.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1623,R30
; 0000 0129 // Interrupt 0 level: Disabled
; 0000 012A // Interrupt 1 level: Disabled
; 0000 012B PORTC.INTCTRL=(PORTC.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 012C 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1609
	ANDI R30,LOW(0xF0)
	STS  1609,R30
; 0000 012D // Bit0 pin change interrupt 0: Off
; 0000 012E // Bit1 pin change interrupt 0: Off
; 0000 012F // Bit2 pin change interrupt 0: Off
; 0000 0130 // Bit3 pin change interrupt 0: Off
; 0000 0131 // Bit4 pin change interrupt 0: Off
; 0000 0132 // Bit5 pin change interrupt 0: Off
; 0000 0133 // Bit6 pin change interrupt 0: Off
; 0000 0134 // Bit7 pin change interrupt 0: Off
; 0000 0135 PORTC.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1610,R30
; 0000 0136 // Bit0 pin change interrupt 1: Off
; 0000 0137 // Bit1 pin change interrupt 1: Off
; 0000 0138 // Bit2 pin change interrupt 1: Off
; 0000 0139 // Bit3 pin change interrupt 1: Off
; 0000 013A // Bit4 pin change interrupt 1: Off
; 0000 013B // Bit5 pin change interrupt 1: Off
; 0000 013C // Bit6 pin change interrupt 1: Off
; 0000 013D // Bit7 pin change interrupt 1: Off
; 0000 013E PORTC.INT1MASK=0x00;
	STS  1611,R30
; 0000 013F 
; 0000 0140 // PORTD initialization
; 0000 0141 // OUT register
; 0000 0142 PORTD.OUT=0x00;
	STS  1636,R30
; 0000 0143 // Bit0: Input
; 0000 0144 // Bit1: Input
; 0000 0145 // Bit2: Input
; 0000 0146 // Bit3: Input
; 0000 0147 // Bit4: Input
; 0000 0148 // Bit5: Input
; 0000 0149 // Bit6: Input
; 0000 014A // Bit7: Input
; 0000 014B PORTD.DIR=0x00;
	STS  1632,R30
; 0000 014C // Bit0 Output/Pull configuration: Totempole/No
; 0000 014D // Bit0 Input/Sense configuration: Sense both edges
; 0000 014E // Bit0 inverted: Off
; 0000 014F // Bit0 slew rate limitation: Off
; 0000 0150 PORTD.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1648,R30
; 0000 0151 // Bit1 Output/Pull configuration: Totempole/No
; 0000 0152 // Bit1 Input/Sense configuration: Sense both edges
; 0000 0153 // Bit1 inverted: Off
; 0000 0154 // Bit1 slew rate limitation: Off
; 0000 0155 PORTD.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1649,R30
; 0000 0156 // Bit2 Output/Pull configuration: Totempole/No
; 0000 0157 // Bit2 Input/Sense configuration: Sense both edges
; 0000 0158 // Bit2 inverted: Off
; 0000 0159 // Bit2 slew rate limitation: Off
; 0000 015A PORTD.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1650,R30
; 0000 015B // Bit3 Output/Pull configuration: Totempole/No
; 0000 015C // Bit3 Input/Sense configuration: Sense both edges
; 0000 015D // Bit3 inverted: Off
; 0000 015E // Bit3 slew rate limitation: Off
; 0000 015F PORTD.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1651,R30
; 0000 0160 // Bit4 Output/Pull configuration: Totempole/No
; 0000 0161 // Bit4 Input/Sense configuration: Sense both edges
; 0000 0162 // Bit4 inverted: Off
; 0000 0163 // Bit4 slew rate limitation: Off
; 0000 0164 PORTD.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1652,R30
; 0000 0165 // Bit5 Output/Pull configuration: Totempole/No
; 0000 0166 // Bit5 Input/Sense configuration: Sense both edges
; 0000 0167 // Bit5 inverted: Off
; 0000 0168 // Bit5 slew rate limitation: Off
; 0000 0169 PORTD.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1653,R30
; 0000 016A // Bit6 Output/Pull configuration: Totempole/No
; 0000 016B // Bit6 Input/Sense configuration: Sense both edges
; 0000 016C // Bit6 inverted: Off
; 0000 016D // Bit6 slew rate limitation: Off
; 0000 016E PORTD.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1654,R30
; 0000 016F // Bit7 Output/Pull configuration: Totempole/No
; 0000 0170 // Bit7 Input/Sense configuration: Sense both edges
; 0000 0171 // Bit7 inverted: Off
; 0000 0172 // Bit7 slew rate limitation: Off
; 0000 0173 PORTD.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1655,R30
; 0000 0174 // Interrupt 0 level: Disabled
; 0000 0175 // Interrupt 1 level: Disabled
; 0000 0176 PORTD.INTCTRL=(PORTD.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0177 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1641
	ANDI R30,LOW(0xF0)
	STS  1641,R30
; 0000 0178 // Bit0 pin change interrupt 0: Off
; 0000 0179 // Bit1 pin change interrupt 0: Off
; 0000 017A // Bit2 pin change interrupt 0: Off
; 0000 017B // Bit3 pin change interrupt 0: Off
; 0000 017C // Bit4 pin change interrupt 0: Off
; 0000 017D // Bit5 pin change interrupt 0: Off
; 0000 017E // Bit6 pin change interrupt 0: Off
; 0000 017F // Bit7 pin change interrupt 0: Off
; 0000 0180 PORTD.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1642,R30
; 0000 0181 // Bit0 pin change interrupt 1: Off
; 0000 0182 // Bit1 pin change interrupt 1: Off
; 0000 0183 // Bit2 pin change interrupt 1: Off
; 0000 0184 // Bit3 pin change interrupt 1: Off
; 0000 0185 // Bit4 pin change interrupt 1: Off
; 0000 0186 // Bit5 pin change interrupt 1: Off
; 0000 0187 // Bit6 pin change interrupt 1: Off
; 0000 0188 // Bit7 pin change interrupt 1: Off
; 0000 0189 PORTD.INT1MASK=0x00;
	STS  1643,R30
; 0000 018A 
; 0000 018B // PORTE initialization
; 0000 018C // OUT register
; 0000 018D PORTE.OUT=0x00;
	STS  1668,R30
; 0000 018E // Bit0: Input
; 0000 018F // Bit1: Input
; 0000 0190 // Bit2: Input
; 0000 0191 // Bit3: Input
; 0000 0192 // Bit4: Input
; 0000 0193 // Bit5: Input
; 0000 0194 // Bit6: Input
; 0000 0195 // Bit7: Input
; 0000 0196 PORTE.DIR=0x00;
	STS  1664,R30
; 0000 0197 // Bit0 Output/Pull configuration: Totempole/No
; 0000 0198 // Bit0 Input/Sense configuration: Sense both edges
; 0000 0199 // Bit0 inverted: Off
; 0000 019A // Bit0 slew rate limitation: Off
; 0000 019B PORTE.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1680,R30
; 0000 019C // Bit1 Output/Pull configuration: Totempole/No
; 0000 019D // Bit1 Input/Sense configuration: Sense both edges
; 0000 019E // Bit1 inverted: Off
; 0000 019F // Bit1 slew rate limitation: Off
; 0000 01A0 PORTE.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1681,R30
; 0000 01A1 // Bit2 Output/Pull configuration: Totempole/No
; 0000 01A2 // Bit2 Input/Sense configuration: Sense both edges
; 0000 01A3 // Bit2 inverted: Off
; 0000 01A4 // Bit2 slew rate limitation: Off
; 0000 01A5 PORTE.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1682,R30
; 0000 01A6 // Bit3 Output/Pull configuration: Totempole/No
; 0000 01A7 // Bit3 Input/Sense configuration: Sense both edges
; 0000 01A8 // Bit3 inverted: Off
; 0000 01A9 // Bit3 slew rate limitation: Off
; 0000 01AA PORTE.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1683,R30
; 0000 01AB // Bit4 Output/Pull configuration: Totempole/No
; 0000 01AC // Bit4 Input/Sense configuration: Sense both edges
; 0000 01AD // Bit4 inverted: Off
; 0000 01AE // Bit4 slew rate limitation: Off
; 0000 01AF PORTE.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1684,R30
; 0000 01B0 // Bit5 Output/Pull configuration: Totempole/No
; 0000 01B1 // Bit5 Input/Sense configuration: Sense both edges
; 0000 01B2 // Bit5 inverted: Off
; 0000 01B3 // Bit5 slew rate limitation: Off
; 0000 01B4 PORTE.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1685,R30
; 0000 01B5 // Bit6 Output/Pull configuration: Totempole/No
; 0000 01B6 // Bit6 Input/Sense configuration: Sense both edges
; 0000 01B7 // Bit6 inverted: Off
; 0000 01B8 // Bit6 slew rate limitation: Off
; 0000 01B9 PORTE.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1686,R30
; 0000 01BA // Bit7 Output/Pull configuration: Totempole/No
; 0000 01BB // Bit7 Input/Sense configuration: Sense both edges
; 0000 01BC // Bit7 inverted: Off
; 0000 01BD // Bit7 slew rate limitation: Off
; 0000 01BE PORTE.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1687,R30
; 0000 01BF // Interrupt 0 level: Disabled
; 0000 01C0 // Interrupt 1 level: Disabled
; 0000 01C1 PORTE.INTCTRL=(PORTE.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 01C2 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1673
	ANDI R30,LOW(0xF0)
	STS  1673,R30
; 0000 01C3 // Bit0 pin change interrupt 0: Off
; 0000 01C4 // Bit1 pin change interrupt 0: Off
; 0000 01C5 // Bit2 pin change interrupt 0: Off
; 0000 01C6 // Bit3 pin change interrupt 0: Off
; 0000 01C7 // Bit4 pin change interrupt 0: Off
; 0000 01C8 // Bit5 pin change interrupt 0: Off
; 0000 01C9 // Bit6 pin change interrupt 0: Off
; 0000 01CA // Bit7 pin change interrupt 0: Off
; 0000 01CB PORTE.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1674,R30
; 0000 01CC // Bit0 pin change interrupt 1: Off
; 0000 01CD // Bit1 pin change interrupt 1: Off
; 0000 01CE // Bit2 pin change interrupt 1: Off
; 0000 01CF // Bit3 pin change interrupt 1: Off
; 0000 01D0 // Bit4 pin change interrupt 1: Off
; 0000 01D1 // Bit5 pin change interrupt 1: Off
; 0000 01D2 // Bit6 pin change interrupt 1: Off
; 0000 01D3 // Bit7 pin change interrupt 1: Off
; 0000 01D4 PORTE.INT1MASK=0x00;
	STS  1675,R30
; 0000 01D5 
; 0000 01D6 // PORTF initialization
; 0000 01D7 // OUT register
; 0000 01D8 PORTF.OUT=0x00;
	STS  1700,R30
; 0000 01D9 // Bit0: Input
; 0000 01DA // Bit1: Input
; 0000 01DB // Bit2: Input
; 0000 01DC // Bit3: Input
; 0000 01DD // Bit4: Input
; 0000 01DE // Bit5: Input
; 0000 01DF // Bit6: Input
; 0000 01E0 // Bit7: Input
; 0000 01E1 PORTF.DIR=0x00;
	STS  1696,R30
; 0000 01E2 // Bit0 Output/Pull configuration: Totempole/No
; 0000 01E3 // Bit0 Input/Sense configuration: Sense both edges
; 0000 01E4 // Bit0 inverted: Off
; 0000 01E5 // Bit0 slew rate limitation: Off
; 0000 01E6 PORTF.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1712,R30
; 0000 01E7 // Bit1 Output/Pull configuration: Totempole/No
; 0000 01E8 // Bit1 Input/Sense configuration: Sense both edges
; 0000 01E9 // Bit1 inverted: Off
; 0000 01EA // Bit1 slew rate limitation: Off
; 0000 01EB PORTF.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1713,R30
; 0000 01EC // Bit2 Output/Pull configuration: Totempole/No
; 0000 01ED // Bit2 Input/Sense configuration: Sense both edges
; 0000 01EE // Bit2 inverted: Off
; 0000 01EF // Bit2 slew rate limitation: Off
; 0000 01F0 PORTF.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1714,R30
; 0000 01F1 // Bit3 Output/Pull configuration: Totempole/No
; 0000 01F2 // Bit3 Input/Sense configuration: Sense both edges
; 0000 01F3 // Bit3 inverted: Off
; 0000 01F4 // Bit3 slew rate limitation: Off
; 0000 01F5 PORTF.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1715,R30
; 0000 01F6 // Bit4 Output/Pull configuration: Totempole/No
; 0000 01F7 // Bit4 Input/Sense configuration: Sense both edges
; 0000 01F8 // Bit4 inverted: Off
; 0000 01F9 // Bit4 slew rate limitation: Off
; 0000 01FA PORTF.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1716,R30
; 0000 01FB // Bit5 Output/Pull configuration: Totempole/No
; 0000 01FC // Bit5 Input/Sense configuration: Sense both edges
; 0000 01FD // Bit5 inverted: Off
; 0000 01FE // Bit5 slew rate limitation: Off
; 0000 01FF PORTF.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1717,R30
; 0000 0200 // Bit6 Output/Pull configuration: Totempole/No
; 0000 0201 // Bit6 Input/Sense configuration: Sense both edges
; 0000 0202 // Bit6 inverted: Off
; 0000 0203 // Bit6 slew rate limitation: Off
; 0000 0204 PORTF.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1718,R30
; 0000 0205 // Bit7 Output/Pull configuration: Totempole/No
; 0000 0206 // Bit7 Input/Sense configuration: Sense both edges
; 0000 0207 // Bit7 inverted: Off
; 0000 0208 // Bit7 slew rate limitation: Off
; 0000 0209 PORTF.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1719,R30
; 0000 020A // Interrupt 0 level: Disabled
; 0000 020B // Interrupt 1 level: Disabled
; 0000 020C PORTF.INTCTRL=(PORTF.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 020D 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1705
	ANDI R30,LOW(0xF0)
	STS  1705,R30
; 0000 020E // Bit0 pin change interrupt 0: Off
; 0000 020F // Bit1 pin change interrupt 0: Off
; 0000 0210 // Bit2 pin change interrupt 0: Off
; 0000 0211 // Bit3 pin change interrupt 0: Off
; 0000 0212 // Bit4 pin change interrupt 0: Off
; 0000 0213 // Bit5 pin change interrupt 0: Off
; 0000 0214 // Bit6 pin change interrupt 0: Off
; 0000 0215 // Bit7 pin change interrupt 0: Off
; 0000 0216 PORTF.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1706,R30
; 0000 0217 // Bit0 pin change interrupt 1: Off
; 0000 0218 // Bit1 pin change interrupt 1: Off
; 0000 0219 // Bit2 pin change interrupt 1: Off
; 0000 021A // Bit3 pin change interrupt 1: Off
; 0000 021B // Bit4 pin change interrupt 1: Off
; 0000 021C // Bit5 pin change interrupt 1: Off
; 0000 021D // Bit6 pin change interrupt 1: Off
; 0000 021E // Bit7 pin change interrupt 1: Off
; 0000 021F PORTF.INT1MASK=0x00;
	STS  1707,R30
; 0000 0220 
; 0000 0221 // PORTH initialization
; 0000 0222 // OUT register
; 0000 0223 PORTH.OUT=0x00;
	STS  1764,R30
; 0000 0224 // Bit0: Input
; 0000 0225 // Bit1: Input
; 0000 0226 // Bit2: Input
; 0000 0227 // Bit3: Input
; 0000 0228 // Bit4: Input
; 0000 0229 // Bit5: Input
; 0000 022A // Bit6: Input
; 0000 022B // Bit7: Input
; 0000 022C PORTH.DIR=0x00;
	STS  1760,R30
; 0000 022D // Bit0 Output/Pull configuration: Totempole/No
; 0000 022E // Bit0 Input/Sense configuration: Sense both edges
; 0000 022F // Bit0 inverted: Off
; 0000 0230 // Bit0 slew rate limitation: Off
; 0000 0231 PORTH.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1776,R30
; 0000 0232 // Bit1 Output/Pull configuration: Totempole/No
; 0000 0233 // Bit1 Input/Sense configuration: Sense both edges
; 0000 0234 // Bit1 inverted: Off
; 0000 0235 // Bit1 slew rate limitation: Off
; 0000 0236 PORTH.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1777,R30
; 0000 0237 // Bit2 Output/Pull configuration: Totempole/No
; 0000 0238 // Bit2 Input/Sense configuration: Sense both edges
; 0000 0239 // Bit2 inverted: Off
; 0000 023A // Bit2 slew rate limitation: Off
; 0000 023B PORTH.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1778,R30
; 0000 023C // Bit3 Output/Pull configuration: Totempole/No
; 0000 023D // Bit3 Input/Sense configuration: Sense both edges
; 0000 023E // Bit3 inverted: Off
; 0000 023F // Bit3 slew rate limitation: Off
; 0000 0240 PORTH.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1779,R30
; 0000 0241 // Bit4 Output/Pull configuration: Totempole/No
; 0000 0242 // Bit4 Input/Sense configuration: Sense both edges
; 0000 0243 // Bit4 inverted: Off
; 0000 0244 // Bit4 slew rate limitation: Off
; 0000 0245 PORTH.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1780,R30
; 0000 0246 // Bit5 Output/Pull configuration: Totempole/No
; 0000 0247 // Bit5 Input/Sense configuration: Sense both edges
; 0000 0248 // Bit5 inverted: Off
; 0000 0249 // Bit5 slew rate limitation: Off
; 0000 024A PORTH.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1781,R30
; 0000 024B // Bit6 Output/Pull configuration: Totempole/No
; 0000 024C // Bit6 Input/Sense configuration: Sense both edges
; 0000 024D // Bit6 inverted: Off
; 0000 024E // Bit6 slew rate limitation: Off
; 0000 024F PORTH.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1782,R30
; 0000 0250 // Bit7 Output/Pull configuration: Totempole/No
; 0000 0251 // Bit7 Input/Sense configuration: Sense both edges
; 0000 0252 // Bit7 inverted: Off
; 0000 0253 // Bit7 slew rate limitation: Off
; 0000 0254 PORTH.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1783,R30
; 0000 0255 // Interrupt 0 level: Disabled
; 0000 0256 // Interrupt 1 level: Disabled
; 0000 0257 PORTH.INTCTRL=(PORTH.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0258 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1769
	ANDI R30,LOW(0xF0)
	STS  1769,R30
; 0000 0259 // Bit0 pin change interrupt 0: Off
; 0000 025A // Bit1 pin change interrupt 0: Off
; 0000 025B // Bit2 pin change interrupt 0: Off
; 0000 025C // Bit3 pin change interrupt 0: Off
; 0000 025D // Bit4 pin change interrupt 0: Off
; 0000 025E // Bit5 pin change interrupt 0: Off
; 0000 025F // Bit6 pin change interrupt 0: Off
; 0000 0260 // Bit7 pin change interrupt 0: Off
; 0000 0261 PORTH.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1770,R30
; 0000 0262 // Bit0 pin change interrupt 1: Off
; 0000 0263 // Bit1 pin change interrupt 1: Off
; 0000 0264 // Bit2 pin change interrupt 1: Off
; 0000 0265 // Bit3 pin change interrupt 1: Off
; 0000 0266 // Bit4 pin change interrupt 1: Off
; 0000 0267 // Bit5 pin change interrupt 1: Off
; 0000 0268 // Bit6 pin change interrupt 1: Off
; 0000 0269 // Bit7 pin change interrupt 1: Off
; 0000 026A PORTH.INT1MASK=0x00;
	STS  1771,R30
; 0000 026B 
; 0000 026C // PORTJ initialization
; 0000 026D // OUT register
; 0000 026E PORTJ.OUT=0x00;
	STS  1796,R30
; 0000 026F // Bit0: Input
; 0000 0270 // Bit1: Input
; 0000 0271 // Bit2: Input
; 0000 0272 // Bit3: Input
; 0000 0273 // Bit4: Input
; 0000 0274 // Bit5: Input
; 0000 0275 // Bit6: Input
; 0000 0276 // Bit7: Input
; 0000 0277 PORTJ.DIR=0x00;
	STS  1792,R30
; 0000 0278 // Bit0 Output/Pull configuration: Totempole/No
; 0000 0279 // Bit0 Input/Sense configuration: Sense both edges
; 0000 027A // Bit0 inverted: Off
; 0000 027B // Bit0 slew rate limitation: Off
; 0000 027C PORTJ.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1808,R30
; 0000 027D // Bit1 Output/Pull configuration: Totempole/No
; 0000 027E // Bit1 Input/Sense configuration: Sense both edges
; 0000 027F // Bit1 inverted: Off
; 0000 0280 // Bit1 slew rate limitation: Off
; 0000 0281 PORTJ.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1809,R30
; 0000 0282 // Bit2 Output/Pull configuration: Totempole/No
; 0000 0283 // Bit2 Input/Sense configuration: Sense both edges
; 0000 0284 // Bit2 inverted: Off
; 0000 0285 // Bit2 slew rate limitation: Off
; 0000 0286 PORTJ.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1810,R30
; 0000 0287 // Bit3 Output/Pull configuration: Totempole/No
; 0000 0288 // Bit3 Input/Sense configuration: Sense both edges
; 0000 0289 // Bit3 inverted: Off
; 0000 028A // Bit3 slew rate limitation: Off
; 0000 028B PORTJ.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1811,R30
; 0000 028C // Bit4 Output/Pull configuration: Totempole/No
; 0000 028D // Bit4 Input/Sense configuration: Sense both edges
; 0000 028E // Bit4 inverted: Off
; 0000 028F // Bit4 slew rate limitation: Off
; 0000 0290 PORTJ.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1812,R30
; 0000 0291 // Bit5 Output/Pull configuration: Totempole/No
; 0000 0292 // Bit5 Input/Sense configuration: Sense both edges
; 0000 0293 // Bit5 inverted: Off
; 0000 0294 // Bit5 slew rate limitation: Off
; 0000 0295 PORTJ.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1813,R30
; 0000 0296 // Bit6 Output/Pull configuration: Totempole/No
; 0000 0297 // Bit6 Input/Sense configuration: Sense both edges
; 0000 0298 // Bit6 inverted: Off
; 0000 0299 // Bit6 slew rate limitation: Off
; 0000 029A PORTJ.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1814,R30
; 0000 029B // Bit7 Output/Pull configuration: Totempole/No
; 0000 029C // Bit7 Input/Sense configuration: Sense both edges
; 0000 029D // Bit7 inverted: Off
; 0000 029E // Bit7 slew rate limitation: Off
; 0000 029F PORTJ.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1815,R30
; 0000 02A0 // Interrupt 0 level: Disabled
; 0000 02A1 // Interrupt 1 level: Disabled
; 0000 02A2 PORTJ.INTCTRL=(PORTJ.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 02A3 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1801
	ANDI R30,LOW(0xF0)
	STS  1801,R30
; 0000 02A4 // Bit0 pin change interrupt 0: Off
; 0000 02A5 // Bit1 pin change interrupt 0: Off
; 0000 02A6 // Bit2 pin change interrupt 0: Off
; 0000 02A7 // Bit3 pin change interrupt 0: Off
; 0000 02A8 // Bit4 pin change interrupt 0: Off
; 0000 02A9 // Bit5 pin change interrupt 0: Off
; 0000 02AA // Bit6 pin change interrupt 0: Off
; 0000 02AB // Bit7 pin change interrupt 0: Off
; 0000 02AC PORTJ.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1802,R30
; 0000 02AD // Bit0 pin change interrupt 1: Off
; 0000 02AE // Bit1 pin change interrupt 1: Off
; 0000 02AF // Bit2 pin change interrupt 1: Off
; 0000 02B0 // Bit3 pin change interrupt 1: Off
; 0000 02B1 // Bit4 pin change interrupt 1: Off
; 0000 02B2 // Bit5 pin change interrupt 1: Off
; 0000 02B3 // Bit6 pin change interrupt 1: Off
; 0000 02B4 // Bit7 pin change interrupt 1: Off
; 0000 02B5 PORTJ.INT1MASK=0x00;
	STS  1803,R30
; 0000 02B6 
; 0000 02B7 // PORTK initialization
; 0000 02B8 // OUT register
; 0000 02B9 PORTK.OUT=0x00;
	STS  1828,R30
; 0000 02BA // Bit0: Input
; 0000 02BB // Bit1: Input
; 0000 02BC // Bit2: Input
; 0000 02BD // Bit3: Input
; 0000 02BE // Bit4: Input
; 0000 02BF // Bit5: Input
; 0000 02C0 // Bit6: Input
; 0000 02C1 // Bit7: Input
; 0000 02C2 PORTK.DIR=0x00;
	STS  1824,R30
; 0000 02C3 // Bit0 Output/Pull configuration: Totempole/No
; 0000 02C4 // Bit0 Input/Sense configuration: Sense both edges
; 0000 02C5 // Bit0 inverted: Off
; 0000 02C6 // Bit0 slew rate limitation: Off
; 0000 02C7 PORTK.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1840,R30
; 0000 02C8 // Bit1 Output/Pull configuration: Totempole/No
; 0000 02C9 // Bit1 Input/Sense configuration: Sense both edges
; 0000 02CA // Bit1 inverted: Off
; 0000 02CB // Bit1 slew rate limitation: Off
; 0000 02CC PORTK.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1841,R30
; 0000 02CD // Bit2 Output/Pull configuration: Totempole/No
; 0000 02CE // Bit2 Input/Sense configuration: Sense both edges
; 0000 02CF // Bit2 inverted: Off
; 0000 02D0 // Bit2 slew rate limitation: Off
; 0000 02D1 PORTK.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1842,R30
; 0000 02D2 // Bit3 Output/Pull configuration: Totempole/No
; 0000 02D3 // Bit3 Input/Sense configuration: Sense both edges
; 0000 02D4 // Bit3 inverted: Off
; 0000 02D5 // Bit3 slew rate limitation: Off
; 0000 02D6 PORTK.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1843,R30
; 0000 02D7 // Bit4 Output/Pull configuration: Totempole/No
; 0000 02D8 // Bit4 Input/Sense configuration: Sense both edges
; 0000 02D9 // Bit4 inverted: Off
; 0000 02DA // Bit4 slew rate limitation: Off
; 0000 02DB PORTK.PIN4CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1844,R30
; 0000 02DC // Bit5 Output/Pull configuration: Totempole/No
; 0000 02DD // Bit5 Input/Sense configuration: Sense both edges
; 0000 02DE // Bit5 inverted: Off
; 0000 02DF // Bit5 slew rate limitation: Off
; 0000 02E0 PORTK.PIN5CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1845,R30
; 0000 02E1 // Bit6 Output/Pull configuration: Totempole/No
; 0000 02E2 // Bit6 Input/Sense configuration: Sense both edges
; 0000 02E3 // Bit6 inverted: Off
; 0000 02E4 // Bit6 slew rate limitation: Off
; 0000 02E5 PORTK.PIN6CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1846,R30
; 0000 02E6 // Bit7 Output/Pull configuration: Totempole/No
; 0000 02E7 // Bit7 Input/Sense configuration: Sense both edges
; 0000 02E8 // Bit7 inverted: Off
; 0000 02E9 // Bit7 slew rate limitation: Off
; 0000 02EA PORTK.PIN7CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  1847,R30
; 0000 02EB // Interrupt 0 level: Disabled
; 0000 02EC // Interrupt 1 level: Disabled
; 0000 02ED PORTK.INTCTRL=(PORTK.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 02EE 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1833
	ANDI R30,LOW(0xF0)
	STS  1833,R30
; 0000 02EF // Bit0 pin change interrupt 0: Off
; 0000 02F0 // Bit1 pin change interrupt 0: Off
; 0000 02F1 // Bit2 pin change interrupt 0: Off
; 0000 02F2 // Bit3 pin change interrupt 0: Off
; 0000 02F3 // Bit4 pin change interrupt 0: Off
; 0000 02F4 // Bit5 pin change interrupt 0: Off
; 0000 02F5 // Bit6 pin change interrupt 0: Off
; 0000 02F6 // Bit7 pin change interrupt 0: Off
; 0000 02F7 PORTK.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1834,R30
; 0000 02F8 // Bit0 pin change interrupt 1: Off
; 0000 02F9 // Bit1 pin change interrupt 1: Off
; 0000 02FA // Bit2 pin change interrupt 1: Off
; 0000 02FB // Bit3 pin change interrupt 1: Off
; 0000 02FC // Bit4 pin change interrupt 1: Off
; 0000 02FD // Bit5 pin change interrupt 1: Off
; 0000 02FE // Bit6 pin change interrupt 1: Off
; 0000 02FF // Bit7 pin change interrupt 1: Off
; 0000 0300 PORTK.INT1MASK=0x00;
	STS  1835,R30
; 0000 0301 
; 0000 0302 // PORTQ initialization
; 0000 0303 // OUT register
; 0000 0304 PORTQ.OUT=0x00;
	STS  1988,R30
; 0000 0305 // Bit0: Input
; 0000 0306 // Bit1: Input
; 0000 0307 // Bit2: Input
; 0000 0308 // Bit3: Input
; 0000 0309 PORTQ.DIR=0x00;
	STS  1984,R30
; 0000 030A // Bit0 Output/Pull configuration: Totempole/No
; 0000 030B // Bit0 Input/Sense configuration: Sense both edges
; 0000 030C // Bit0 inverted: Off
; 0000 030D // Bit0 slew rate limitation: Off
; 0000 030E PORTQ.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2000,R30
; 0000 030F // Bit1 Output/Pull configuration: Totempole/No
; 0000 0310 // Bit1 Input/Sense configuration: Sense both edges
; 0000 0311 // Bit1 inverted: Off
; 0000 0312 // Bit1 slew rate limitation: Off
; 0000 0313 PORTQ.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2001,R30
; 0000 0314 // Bit2 Output/Pull configuration: Totempole/No
; 0000 0315 // Bit2 Input/Sense configuration: Sense both edges
; 0000 0316 // Bit2 inverted: Off
; 0000 0317 // Bit2 slew rate limitation: Off
; 0000 0318 PORTQ.PIN2CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2002,R30
; 0000 0319 // Bit3 Output/Pull configuration: Totempole/No
; 0000 031A // Bit3 Input/Sense configuration: Sense both edges
; 0000 031B // Bit3 inverted: Off
; 0000 031C // Bit3 slew rate limitation: Off
; 0000 031D PORTQ.PIN3CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2003,R30
; 0000 031E // Interrupt 0 level: Disabled
; 0000 031F // Interrupt 1 level: Disabled
; 0000 0320 PORTQ.INTCTRL=(PORTQ.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0321 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,1993
	ANDI R30,LOW(0xF0)
	STS  1993,R30
; 0000 0322 // Bit0 pin change interrupt 0: Off
; 0000 0323 // Bit1 pin change interrupt 0: Off
; 0000 0324 // Bit2 pin change interrupt 0: Off
; 0000 0325 // Bit3 pin change interrupt 0: Off
; 0000 0326 PORTQ.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  1994,R30
; 0000 0327 // Bit0 pin change interrupt 1: Off
; 0000 0328 // Bit1 pin change interrupt 1: Off
; 0000 0329 // Bit2 pin change interrupt 1: Off
; 0000 032A // Bit3 pin change interrupt 1: Off
; 0000 032B PORTQ.INT1MASK=0x00;
	STS  1995,R30
; 0000 032C 
; 0000 032D // PORTR initialization
; 0000 032E // OUT register
; 0000 032F PORTR.OUT=0x00;
	STS  2020,R30
; 0000 0330 // Bit0: Input
; 0000 0331 // Bit1: Input
; 0000 0332 PORTR.DIR=0x00;
	STS  2016,R30
; 0000 0333 // Bit0 Output/Pull configuration: Totempole/No
; 0000 0334 // Bit0 Input/Sense configuration: Sense both edges
; 0000 0335 // Bit0 inverted: Off
; 0000 0336 // Bit0 slew rate limitation: Off
; 0000 0337 PORTR.PIN0CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2032,R30
; 0000 0338 // Bit1 Output/Pull configuration: Totempole/No
; 0000 0339 // Bit1 Input/Sense configuration: Sense both edges
; 0000 033A // Bit1 inverted: Off
; 0000 033B // Bit1 slew rate limitation: Off
; 0000 033C PORTR.PIN1CTRL=PORT_OPC_TOTEM_gc | PORT_ISC_BOTHEDGES_gc;
	STS  2033,R30
; 0000 033D // Interrupt 0 level: Disabled
; 0000 033E // Interrupt 1 level: Disabled
; 0000 033F PORTR.INTCTRL=(PORTR.INTCTRL & (~(PORT_INT1LVL_gm | PORT_INT0LVL_gm))) |
; 0000 0340 	PORT_INT1LVL_OFF_gc | PORT_INT0LVL_OFF_gc;
	LDS  R30,2025
	ANDI R30,LOW(0xF0)
	STS  2025,R30
; 0000 0341 // Bit0 pin change interrupt 0: Off
; 0000 0342 // Bit1 pin change interrupt 0: Off
; 0000 0343 PORTR.INT0MASK=0x00;
	LDI  R30,LOW(0)
	STS  2026,R30
; 0000 0344 // Bit0 pin change interrupt 1: Off
; 0000 0345 // Bit1 pin change interrupt 1: Off
; 0000 0346 PORTR.INT1MASK=0x00;
	STS  2027,R30
; 0000 0347 }
	RET
;
;// Virtual Ports initialization
;void vports_init(void)
; 0000 034B {
_vports_init:
; 0000 034C // PORTA mapped to VPORT0
; 0000 034D // PORTB mapped to VPORT1
; 0000 034E PORTCFG.VPCTRLA=PORTCFG_VP1MAP_PORTB_gc | PORTCFG_VP0MAP_PORTA_gc;
	LDI  R30,LOW(16)
	STS  178,R30
; 0000 034F // PORTC mapped to VPORT2
; 0000 0350 // PORTD mapped to VPORT3
; 0000 0351 PORTCFG.VPCTRLB=PORTCFG_VP3MAP_PORTD_gc | PORTCFG_VP2MAP_PORTC_gc;
	LDI  R30,LOW(50)
	STS  179,R30
; 0000 0352 }
	RET
;
;// Function used to read the calibration byte from the
;// signature row, specified by 'index'
;#pragma optsize-
;unsigned char read_calibration_byte(unsigned char index)
; 0000 0358 {
_read_calibration_byte:
; 0000 0359 unsigned char r;
; 0000 035A NVM.CMD=NVM_CMD_READ_CALIB_ROW_gc;
	ST   -Y,R17
;	index -> Y+1
;	r -> R17
	LDI  R30,LOW(2)
	STS  458,R30
; 0000 035B r=*((flash unsigned char*) index);
	LDD  R30,Y+1
	LDI  R31,0
	LPM  R17,Z
; 0000 035C // Clean up NVM command register
; 0000 035D NVM.CMD=NVM_CMD_NO_OPERATION_gc;
	LDI  R30,LOW(0)
	STS  458,R30
; 0000 035E return r;
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x20C0007
; 0000 035F }
;#pragma optsize_default
;
;// ADCA initialization
;void adca_init(void)
; 0000 0364 {
_adca_init:
; 0000 0365 // ADCA is enabled
; 0000 0366 // Resolution: 12 Bits
; 0000 0367 // Load the calibration value for 12 Bit resolution
; 0000 0368 // from the signature row
; 0000 0369 ADCA.CALL=read_calibration_byte(PROD_SIGNATURES_START+ADCACAL0_offset);
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL _read_calibration_byte
	STS  524,R30
; 0000 036A ADCA.CALH=read_calibration_byte(PROD_SIGNATURES_START+ADCACAL1_offset);
	LDI  R30,LOW(33)
	ST   -Y,R30
	RCALL _read_calibration_byte
	STS  525,R30
; 0000 036B 
; 0000 036C // Free Running mode: Off
; 0000 036D // Conversion mode: Unsigned
; 0000 036E ADCA.CTRLB=(ADCA.CTRLB & (~(ADC_CONMODE_bm | ADC_FREERUN_bm | ADC_RESOLUTION_gm))) |
; 0000 036F 	ADC_RESOLUTION_12BIT_gc;
	LDS  R30,513
	ANDI R30,LOW(0xE1)
	STS  513,R30
; 0000 0370 
; 0000 0371 // Clock frequency: 15.625 kHz
; 0000 0372 ADCA.PRESCALER=(ADCA.PRESCALER & (~ADC_PRESCALER_gm)) | ADC_PRESCALER_DIV128_gc;
	LDS  R30,516
	ANDI R30,LOW(0xF8)
	ORI  R30,LOW(0x5)
	STS  516,R30
; 0000 0373 
; 0000 0374 // Reference: Internal 1.00 V
; 0000 0375 // Temperature reference: On
; 0000 0376 ADCA.REFCTRL=(ADCA.REFCTRL & ((~(ADC_REFSEL_gm | ADC_TEMPREF_bm)) | ADC_BANDGAP_bm)) |
; 0000 0377 	ADC_REFSEL_INT1V_gc | ADC_TEMPREF_bm | ADC_BANDGAP_bm;
	LDS  R30,514
	ANDI R30,LOW(0xCE)
	ORI  R30,LOW(0x3)
	STS  514,R30
; 0000 0378 
; 0000 0379 // Initialize the ADC Compare register
; 0000 037A ADCA.CMPL=0x00;
	LDI  R30,LOW(0)
	STS  536,R30
; 0000 037B ADCA.CMPH=0x00;
	STS  537,R30
; 0000 037C 
; 0000 037D // ADC channel 0 gain: 1
; 0000 037E // ADC channel 0 input mode: Single-ended positive input signal
; 0000 037F ADCA.CH0.CTRL=(ADCA.CH0.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
; 0000 0380 	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_SINGLEENDED_gc;
	LDS  R30,544
	ANDI R30,LOW(0x60)
	ORI  R30,1
	STS  544,R30
; 0000 0381 
; 0000 0382 // ADC channel 0 positive input: ADC0 pin
; 0000 0383 // ADC channel 0 negative input: GND
; 0000 0384 ADCA.CH0.MUXCTRL=(ADCA.CH0.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
; 0000 0385 	ADC_CH_MUXPOS_PIN0_gc;
	LDS  R30,545
	ANDI R30,LOW(0x84)
	STS  545,R30
; 0000 0386 
; 0000 0387 // ADC channel 1 gain: 1
; 0000 0388 // ADC channel 1 input mode: Internal positive input signal
; 0000 0389 ADCA.CH1.CTRL=(ADCA.CH1.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
; 0000 038A 	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_INTERNAL_gc;
	LDS  R30,552
	ANDI R30,LOW(0x60)
	STS  552,R30
; 0000 038B 
; 0000 038C // ADC channel 1 positive input: Temp. Reference
; 0000 038D // ADC channel 1 negative input: GND
; 0000 038E ADCA.CH1.MUXCTRL=(ADCA.CH1.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
; 0000 038F 	ADC_CH_MUXINT_TEMP_gc;
	LDS  R30,553
	ANDI R30,LOW(0x84)
	STS  553,R30
; 0000 0390 
; 0000 0391 // ADC channel 2 gain: 1
; 0000 0392 // ADC channel 2 input mode: Internal positive input signal
; 0000 0393 ADCA.CH2.CTRL=(ADCA.CH2.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
; 0000 0394 	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_INTERNAL_gc;
	LDS  R30,560
	ANDI R30,LOW(0x60)
	STS  560,R30
; 0000 0395 
; 0000 0396 // ADC channel 2 positive input: Temp. Reference
; 0000 0397 // ADC channel 2 negative input: GND
; 0000 0398 ADCA.CH2.MUXCTRL=(ADCA.CH2.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
; 0000 0399 	ADC_CH_MUXINT_TEMP_gc;
	LDS  R30,561
	ANDI R30,LOW(0x84)
	STS  561,R30
; 0000 039A 
; 0000 039B // ADC channel 3 gain: 1
; 0000 039C // ADC channel 3 input mode: Internal positive input signal
; 0000 039D ADCA.CH3.CTRL=(ADCA.CH3.CTRL & (~(ADC_CH_START_bm | ADC_CH_GAINFAC_gm | ADC_CH_INPUTMODE_gm))) |
; 0000 039E 	ADC_CH_GAIN_1X_gc | ADC_CH_INPUTMODE_INTERNAL_gc;
	LDS  R30,568
	ANDI R30,LOW(0x60)
	STS  568,R30
; 0000 039F 
; 0000 03A0 // ADC channel 3 positive input: Temp. Reference
; 0000 03A1 // ADC channel 3 negative input: GND
; 0000 03A2 ADCA.CH3.MUXCTRL=(ADCA.CH3.MUXCTRL & (~(ADC_CH_MUXPOS_gm | ADC_CH_MUXNEG_gm))) |
; 0000 03A3 	ADC_CH_MUXINT_TEMP_gc;
	LDS  R30,569
	ANDI R30,LOW(0x84)
	STS  569,R30
; 0000 03A4 
; 0000 03A5 // AD conversion is started by software
; 0000 03A6 ADCA.EVCTRL=ADC_EVACT_NONE_gc;
	LDI  R30,LOW(0)
	STS  515,R30
; 0000 03A7 
; 0000 03A8 // Channel 0 interrupt: Disabled
; 0000 03A9 ADCA.CH0.INTCTRL=(ADCA.CH0.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
; 0000 03AA 	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
	LDS  R30,546
	ANDI R30,LOW(0xF0)
	STS  546,R30
; 0000 03AB // Channel 1 interrupt: Disabled
; 0000 03AC ADCA.CH1.INTCTRL=(ADCA.CH1.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
; 0000 03AD 	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
	LDS  R30,554
	ANDI R30,LOW(0xF0)
	STS  554,R30
; 0000 03AE // Channel 2 interrupt: Disabled
; 0000 03AF ADCA.CH2.INTCTRL=(ADCA.CH2.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
; 0000 03B0 	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
	LDS  R30,562
	ANDI R30,LOW(0xF0)
	STS  562,R30
; 0000 03B1 // Channel 3 interrupt: Disabled
; 0000 03B2 ADCA.CH3.INTCTRL=(ADCA.CH3.INTCTRL & (~(ADC_CH_INTMODE_gm | ADC_CH_INTLVL_gm))) |
; 0000 03B3 	ADC_CH_INTMODE_COMPLETE_gc | ADC_CH_INTLVL_OFF_gc;
	LDS  R30,570
	ANDI R30,LOW(0xF0)
	STS  570,R30
; 0000 03B4 
; 0000 03B5 // Enable the ADC
; 0000 03B6 ADCA.CTRLA|=ADC_ENABLE_bm;
	LDS  R30,512
	ORI  R30,1
	STS  512,R30
; 0000 03B7 // Insert a delay to allow the ADC common mode voltage to stabilize
; 0000 03B8 delay_us(2);
	__DELAY_USB 1
; 0000 03B9 }
	RET
;
;// ADCA channel data read function using polled mode
;unsigned int adca_read(unsigned char channel)
; 0000 03BD {
_adca_read:
; 0000 03BE ADC_CH_t *pch=&ADCA.CH0+channel;
; 0000 03BF unsigned int data;
; 0000 03C0 
; 0000 03C1 // Start the AD conversion
; 0000 03C2 pch->CTRL|=ADC_CH_START_bm;
	CALL __SAVELOCR4
;	channel -> Y+4
;	*pch -> R16,R17
;	data -> R18,R19
	LDD  R30,Y+4
	LDI  R31,0
	LDI  R26,LOW(544)
	LDI  R27,HIGH(544)
	CALL __LSLW3
	ADD  R30,R26
	ADC  R31,R27
	MOVW R16,R30
	MOVW R26,R16
	LD   R30,X
	ORI  R30,0x80
	ST   X,R30
; 0000 03C3 // Wait for the AD conversion to complete
; 0000 03C4 while ((pch->INTFLAGS & ADC_CH_CHIF_bm)==0);
_0x6:
	MOVW R30,R16
	LDD  R26,Z+3
	ANDI R26,LOW(0x1)
	BREQ _0x6
; 0000 03C5 // Clear the interrupt flag
; 0000 03C6 pch->INTFLAGS=ADC_CH_CHIF_bm;
	MOVW R26,R16
	ADIW R26,3
	LDI  R30,LOW(1)
	ST   X,R30
; 0000 03C7 // Read the AD conversion result
; 0000 03C8 ((unsigned char *) &data)[0]=pch->RESL;
	MOVW R26,R16
	ADIW R26,4
	LD   R18,X
; 0000 03C9 ((unsigned char *) &data)[1]=pch->RESH;
	MOVW R26,R16
	ADIW R26,5
	LD   R19,X
; 0000 03CA return data;
	MOVW R30,R18
	CALL __LOADLOCR4
	RJMP _0x20C0005
; 0000 03CB }
;
;// ADCA sweeped channel(s) data read function
;// for software triggered mode
;void adca_sweep_read(unsigned char nch, unsigned int *pdata)
; 0000 03D0 {
; 0000 03D1 ADC_CH_t *pch=&ADCA.CH0;
; 0000 03D2 unsigned char i,j,m;
; 0000 03D3 
; 0000 03D4 // Sweep starts with channel 0
; 0000 03D5 j=ADC_CH0START_bm;
;	nch -> Y+8
;	*pdata -> Y+6
;	*pch -> R16,R17
;	i -> R19
;	j -> R18
;	m -> R21
; 0000 03D6 // Prepare the AD conversion start mask for the sweeped channel(s)
; 0000 03D7 m=0;
; 0000 03D8 i=0;
; 0000 03D9 do
; 0000 03DA   {
; 0000 03DB   m|=j;
; 0000 03DC   j<<=1;
; 0000 03DD   }
; 0000 03DE while (++i<nch);
; 0000 03DF // Ensure the interrupt flags are cleared
; 0000 03E0 ADCA.INTFLAGS=ADCA.INTFLAGS;
; 0000 03E1 // Start the AD conversion for the sweeped channel(s)
; 0000 03E2 ADCA.CTRLA=(ADCA.CTRLA & (ADC_DMASEL_gm | ADC_FLUSH_bm | ADC_ENABLE_bm)) | m;
; 0000 03E3 // Read and store the AD conversion results for all the sweeped channels
; 0000 03E4 for (i=0; i<nch; i++)
; 0000 03E5     {
; 0000 03E6     // Wait for the AD conversion to complete
; 0000 03E7     while ((pch->INTFLAGS & ADC_CH_CHIF_bm)==0);
; 0000 03E8     // Clear the interrupt flag
; 0000 03E9     pch->INTFLAGS=ADC_CH_CHIF_bm;
; 0000 03EA     // Read the AD conversion result
; 0000 03EB     ((unsigned char *) pdata)[0]=pch->RESL;
; 0000 03EC     ((unsigned char *) pdata)[1]=pch->RESH;
; 0000 03ED     pdata++;
; 0000 03EE     pch++;
; 0000 03EF     }
; 0000 03F0 }
;
;void main(void)
; 0000 03F3 {
_main:
; 0000 03F4 // Declare your local variables here
; 0000 03F5 unsigned char n;
; 0000 03F6 
; 0000 03F7 // Interrupt system initialization
; 0000 03F8 // Optimize for speed
; 0000 03F9 #pragma optsize-
; 0000 03FA // Make sure the interrupts are disabled
; 0000 03FB #asm("cli")
;	n -> R17
	cli
; 0000 03FC // Low level interrupt: Off
; 0000 03FD // Round-robin scheduling for low level interrupt: Off
; 0000 03FE // Medium level interrupt: Off
; 0000 03FF // High level interrupt: Off
; 0000 0400 // The interrupt vectors will be placed at the start of the Application FLASH section
; 0000 0401 n=(PMIC.CTRL & (~(PMIC_RREN_bm | PMIC_IVSEL_bm | PMIC_HILVLEN_bm | PMIC_MEDLVLEN_bm | PMIC_LOLVLEN_bm)));
	LDS  R30,162
	ANDI R30,LOW(0x38)
	MOV  R17,R30
; 0000 0402 CCP=CCP_IOREG_gc;
	LDI  R30,LOW(216)
	OUT  0x34,R30
; 0000 0403 PMIC.CTRL=n;
	STS  162,R17
; 0000 0404 // Set the default priority for round-robin scheduling
; 0000 0405 PMIC.INTPRI=0x00;
	LDI  R30,LOW(0)
	STS  161,R30
; 0000 0406 // Restore optimization for size if needed
; 0000 0407 #pragma optsize_default
; 0000 0408 
; 0000 0409 // System clocks initialization
; 0000 040A system_clocks_init();
	RCALL _system_clocks_init
; 0000 040B 
; 0000 040C // Ports initialization
; 0000 040D ports_init();
	RCALL _ports_init
; 0000 040E 
; 0000 040F // Virtual Ports initialization
; 0000 0410 vports_init();
	RCALL _vports_init
; 0000 0411 
; 0000 0412 // ADCA initialization
; 0000 0413 adca_init();
	RCALL _adca_init
; 0000 0414 
; 0000 0415 // Alphanumeric LCD initialization
; 0000 0416 // Connections specified in the
; 0000 0417 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 0418 // RS - PORTH Bit 0
; 0000 0419 // RD - PORTH Bit 1
; 0000 041A // EN - PORTH Bit 2
; 0000 041B // D4 - PORTH Bit 4
; 0000 041C // D5 - PORTH Bit 5
; 0000 041D // D6 - PORTH Bit 6
; 0000 041E // D7 - PORTH Bit 7
; 0000 041F // Characters/line: 8
; 0000 0420 lcd_init(8);
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _lcd_init
; 0000 0421 
; 0000 0422 while (1)
_0x12:
; 0000 0423       {
; 0000 0424             // Place your code here
; 0000 0425             delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x0
; 0000 0426 
; 0000 0427       p=adca_read(0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _adca_read
	LDI  R26,LOW(_p)
	LDI  R27,HIGH(_p)
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __PUTDP1
; 0000 0428       ftoa(p,1,str);
	LDS  R30,_p
	LDS  R31,_p+1
	LDS  R22,_p+2
	LDS  R23,_p+3
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 0429       sprintf(lcd,"ADC %2s ",str);
	LDI  R30,LOW(_lcd)
	LDI  R31,HIGH(_lcd)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_str)
	LDI  R31,HIGH(_str)
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
; 0000 042A       lcd_clear();
	RCALL _lcd_clear
; 0000 042B       lcd_gotoxy(0,8);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _lcd_gotoxy
; 0000 042C       lcd_puts(lcd);
	LDI  R30,LOW(_lcd)
	LDI  R31,HIGH(_lcd)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _lcd_puts
; 0000 042D 
; 0000 042E       }
	RJMP _0x12
; 0000 042F }
_0x15:
	RJMP _0x15

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	LDI  R30,LOW(16)
	STS  1765,R30
	RJMP _0x2000005
_0x2000004:
	LDI  R30,LOW(16)
	STS  1766,R30
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	LDI  R30,LOW(32)
	STS  1765,R30
	RJMP _0x2000007
_0x2000006:
	LDI  R30,LOW(32)
	STS  1766,R30
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	LDI  R30,LOW(64)
	STS  1765,R30
	RJMP _0x2000009
_0x2000008:
	LDI  R30,LOW(64)
	STS  1766,R30
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	LDI  R30,LOW(128)
	STS  1765,R30
	RJMP _0x200000B
_0x200000A:
	LDI  R30,LOW(128)
	STS  1766,R30
_0x200000B:
	__DELAY_USB 1
	LDI  R30,LOW(4)
	STS  1765,R30
	__DELAY_USB 3
	STS  1766,R30
	__DELAY_USB 3
	RJMP _0x20C0006
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 33
	RJMP _0x20C0006
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R2,Y+1
	LDD  R5,Y+0
_0x20C0007:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1
	LDI  R30,LOW(0)
	MOV  R5,R30
	MOV  R2,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	CP   R2,R4
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R5
	ST   -Y,R5
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20C0006
_0x2000013:
_0x2000010:
	INC  R2
	LDI  R30,LOW(1)
	STS  1765,R30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	STS  1766,R30
	RJMP _0x20C0006
_lcd_puts:
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	LDI  R30,LOW(16)
	STS  1761,R30
	LDI  R30,LOW(32)
	STS  1761,R30
	LDI  R30,LOW(64)
	STS  1761,R30
	LDI  R30,LOW(128)
	STS  1761,R30
	LDI  R30,LOW(4)
	STS  1761,R30
	LDI  R30,LOW(1)
	STS  1761,R30
	LDI  R30,LOW(2)
	STS  1761,R30
	LDI  R30,LOW(4)
	STS  1766,R30
	LDI  R30,LOW(1)
	STS  1766,R30
	LDI  R30,LOW(2)
	STS  1766,R30
	LDD  R4,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x0
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2
	CALL SUBOPT_0x2
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 67
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20C0006:
	ADIW R28,1
	RET

	.CSEG
_put_buff_G101:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2020016
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2020018
	__CPWRN 16,17,2
	BRLO _0x2020019
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2020018:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x202001A
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
_0x202001A:
_0x2020019:
	RJMP _0x202001B
_0x2020016:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x202001B:
	LDD  R17,Y+1
	LDD  R16,Y+0
_0x20C0005:
	ADIW R28,5
	RET
__print_G101:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x202001C:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x202001E
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2020022
	CPI  R18,37
	BRNE _0x2020023
	LDI  R17,LOW(1)
	RJMP _0x2020024
_0x2020023:
	CALL SUBOPT_0x3
_0x2020024:
	RJMP _0x2020021
_0x2020022:
	CPI  R30,LOW(0x1)
	BRNE _0x2020025
	CPI  R18,37
	BRNE _0x2020026
	CALL SUBOPT_0x3
	RJMP _0x20200CF
_0x2020026:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2020027
	LDI  R16,LOW(1)
	RJMP _0x2020021
_0x2020027:
	CPI  R18,43
	BRNE _0x2020028
	LDI  R20,LOW(43)
	RJMP _0x2020021
_0x2020028:
	CPI  R18,32
	BRNE _0x2020029
	LDI  R20,LOW(32)
	RJMP _0x2020021
_0x2020029:
	RJMP _0x202002A
_0x2020025:
	CPI  R30,LOW(0x2)
	BRNE _0x202002B
_0x202002A:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x202002C
	ORI  R16,LOW(128)
	RJMP _0x2020021
_0x202002C:
	RJMP _0x202002D
_0x202002B:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x2020021
_0x202002D:
	CPI  R18,48
	BRLO _0x2020030
	CPI  R18,58
	BRLO _0x2020031
_0x2020030:
	RJMP _0x202002F
_0x2020031:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2020021
_0x202002F:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x2020035
	CALL SUBOPT_0x4
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x5
	RJMP _0x2020036
_0x2020035:
	CPI  R30,LOW(0x73)
	BRNE _0x2020038
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2020039
_0x2020038:
	CPI  R30,LOW(0x70)
	BRNE _0x202003B
	CALL SUBOPT_0x4
	CALL SUBOPT_0x6
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2020039:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x202003C
_0x202003B:
	CPI  R30,LOW(0x64)
	BREQ _0x202003F
	CPI  R30,LOW(0x69)
	BRNE _0x2020040
_0x202003F:
	ORI  R16,LOW(4)
	RJMP _0x2020041
_0x2020040:
	CPI  R30,LOW(0x75)
	BRNE _0x2020042
_0x2020041:
	LDI  R30,LOW(_tbl10_G101*2)
	LDI  R31,HIGH(_tbl10_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x2020043
_0x2020042:
	CPI  R30,LOW(0x58)
	BRNE _0x2020045
	ORI  R16,LOW(8)
	RJMP _0x2020046
_0x2020045:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2020077
_0x2020046:
	LDI  R30,LOW(_tbl16_G101*2)
	LDI  R31,HIGH(_tbl16_G101*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x2020043:
	SBRS R16,2
	RJMP _0x2020048
	CALL SUBOPT_0x4
	CALL SUBOPT_0x7
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020049
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2020049:
	CPI  R20,0
	BREQ _0x202004A
	SUBI R17,-LOW(1)
	RJMP _0x202004B
_0x202004A:
	ANDI R16,LOW(251)
_0x202004B:
	RJMP _0x202004C
_0x2020048:
	CALL SUBOPT_0x4
	CALL SUBOPT_0x7
_0x202004C:
_0x202003C:
	SBRC R16,0
	RJMP _0x202004D
_0x202004E:
	CP   R17,R21
	BRSH _0x2020050
	SBRS R16,7
	RJMP _0x2020051
	SBRS R16,2
	RJMP _0x2020052
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x2020053
_0x2020052:
	LDI  R18,LOW(48)
_0x2020053:
	RJMP _0x2020054
_0x2020051:
	LDI  R18,LOW(32)
_0x2020054:
	CALL SUBOPT_0x3
	SUBI R21,LOW(1)
	RJMP _0x202004E
_0x2020050:
_0x202004D:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x2020055
_0x2020056:
	CPI  R19,0
	BREQ _0x2020058
	SBRS R16,3
	RJMP _0x2020059
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x202005A
_0x2020059:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x202005A:
	CALL SUBOPT_0x3
	CPI  R21,0
	BREQ _0x202005B
	SUBI R21,LOW(1)
_0x202005B:
	SUBI R19,LOW(1)
	RJMP _0x2020056
_0x2020058:
	RJMP _0x202005C
_0x2020055:
_0x202005E:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x2020060:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x2020062
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x2020060
_0x2020062:
	CPI  R18,58
	BRLO _0x2020063
	SBRS R16,3
	RJMP _0x2020064
	SUBI R18,-LOW(7)
	RJMP _0x2020065
_0x2020064:
	SUBI R18,-LOW(39)
_0x2020065:
_0x2020063:
	SBRC R16,4
	RJMP _0x2020067
	CPI  R18,49
	BRSH _0x2020069
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2020068
_0x2020069:
	RJMP _0x20200D0
_0x2020068:
	CP   R21,R19
	BRLO _0x202006D
	SBRS R16,0
	RJMP _0x202006E
_0x202006D:
	RJMP _0x202006C
_0x202006E:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x202006F
	LDI  R18,LOW(48)
_0x20200D0:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x2020070
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x5
	CPI  R21,0
	BREQ _0x2020071
	SUBI R21,LOW(1)
_0x2020071:
_0x2020070:
_0x202006F:
_0x2020067:
	CALL SUBOPT_0x3
	CPI  R21,0
	BREQ _0x2020072
	SUBI R21,LOW(1)
_0x2020072:
_0x202006C:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x202005F
	RJMP _0x202005E
_0x202005F:
_0x202005C:
	SBRS R16,0
	RJMP _0x2020073
_0x2020074:
	CPI  R21,0
	BREQ _0x2020076
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x5
	RJMP _0x2020074
_0x2020076:
_0x2020073:
_0x2020077:
_0x2020036:
_0x20200CF:
	LDI  R17,LOW(0)
_0x2020021:
	RJMP _0x202001C
_0x202001E:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x8
	SBIW R30,0
	BRNE _0x2020078
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x20C0004
_0x2020078:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x8
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G101)
	LDI  R31,HIGH(_put_buff_G101)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G101
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x20C0004:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_ftoa:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x204000D
	CALL SUBOPT_0x9
	__POINTW1FN _0x2040000,0
	CALL SUBOPT_0xA
	RJMP _0x20C0003
_0x204000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x204000C
	CALL SUBOPT_0x9
	__POINTW1FN _0x2040000,1
	CALL SUBOPT_0xA
	RJMP _0x20C0003
_0x204000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x204000F
	__GETD1S 9
	CALL __ANEGF1
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
	LDI  R30,LOW(45)
	ST   X,R30
_0x204000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2040010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2040010:
	LDD  R17,Y+8
_0x2040011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2040013
	CALL SUBOPT_0xD
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	RJMP _0x2040011
_0x2040013:
	CALL SUBOPT_0x10
	CALL __ADDF12
	CALL SUBOPT_0xB
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	CALL SUBOPT_0xF
_0x2040014:
	CALL SUBOPT_0x10
	CALL __CMPF12
	BRLO _0x2040016
	CALL SUBOPT_0xD
	CALL SUBOPT_0x11
	CALL SUBOPT_0xF
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2040017
	CALL SUBOPT_0x9
	__POINTW1FN _0x2040000,5
	CALL SUBOPT_0xA
	RJMP _0x20C0003
_0x2040017:
	RJMP _0x2040014
_0x2040016:
	CPI  R17,0
	BRNE _0x2040018
	CALL SUBOPT_0xC
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2040019
_0x2040018:
_0x204001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x204001C
	CALL SUBOPT_0xD
	CALL SUBOPT_0xE
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _floor
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0xC
	CALL SUBOPT_0x12
	CALL SUBOPT_0xD
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	CALL SUBOPT_0x13
	CALL SUBOPT_0x14
	RJMP _0x204001A
_0x204001C:
_0x2040019:
	LDD  R30,Y+8
	CPI  R30,0
	BREQ _0x20C0002
	CALL SUBOPT_0xC
	LDI  R30,LOW(46)
	ST   X,R30
_0x204001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2040020
	CALL SUBOPT_0x13
	CALL SUBOPT_0x11
	CALL SUBOPT_0xB
	__GETD1S 9
	CALL __CFD1U
	MOV  R16,R30
	CALL SUBOPT_0xC
	CALL SUBOPT_0x12
	CALL SUBOPT_0x13
	CALL __CWD1
	CALL __CDF1
	CALL SUBOPT_0x14
	RJMP _0x204001E
_0x2040020:
_0x20C0002:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x20C0003:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	RCALL SUBOPT_0x15
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	RCALL SUBOPT_0x15
	RJMP _0x20C0001
__floor1:
    brtc __floor0
	RCALL SUBOPT_0x15
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x20C0001:
	ADIW R28,4
	RET

	.DSEG
_str:
	.BYTE 0xA
_lcd:
	.BYTE 0xA
_p:
	.BYTE 0x4
__base_y_G100:
	.BYTE 0x4
__seed_G102:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G100
	__DELAY_USB 67
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x6:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x7:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _strcpyf

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xC:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xD:
	__GETD2S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xF:
	__PUTD1S 2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x10:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	__GETD1N 0x41200000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x12:
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	CALL __SWAPD12
	CALL __SUBF12
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x15:
	CALL __GETD1S0
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x1F4
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
